1 #
   2 # Copyright (c) 2008, Oracle and/or its affiliates. All rights reserved.
   3 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
   4 #
   5 # This code is free software; you can redistribute it and/or modify it
   6 # under the terms of the GNU General Public License version 2 only, as
   7 # published by the Free Software Foundation.  Oracle designates this
   8 # particular file as subject to the "Classpath" exception as provided
   9 # by Oracle in the LICENSE file that accompanied this code.
  10 #
  11 # This code is distributed in the hope that it will be useful, but WITHOUT
  12 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  13 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  14 # version 2 for more details (a copy is included in the LICENSE file that
  15 # accompanied this code).
  16 #
  17 # You should have received a copy of the GNU General Public License version
  18 # 2 along with this work; if not, write to the Free Software Foundation,
  19 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  20 #
  21 # Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  22 # or visit www.oracle.com if you need additional information or have any
  23 # questions.
  24 #
  25 
  26 #!/bin/ksh -p
  27 #
  28 #   @test    IOExceptionIfEncodedURLTest.sh
  29 #   @bug     6193279 6619458
  30 #   @summary REGRESSION: AppletViewer throws IOException when path is encoded URL
  31 #   @author  Dmitry Cherepanov: area=appletviewer
  32 #   @run compile IOExceptionIfEncodedURLTest.java
  33 #   @run main IOExceptionIfEncodedURLTest
  34 #   @run shell IOExceptionIfEncodedURLTest.sh
  35 
  36 # Beginning of subroutines:
  37 status=1
  38 
  39 #Call this from anywhere to fail the test with an error message
  40 # usage: fail "reason why the test failed"
  41 fail() 
  42  { echo "The test failed :-("
  43    echo "$*" 1>&2
  44    echo "exit status was $status"
  45    exit $status
  46  } #end of fail()
  47 
  48 #Call this from anywhere to pass the test with a message
  49 # usage: pass "reason why the test passed if applicable"
  50 pass() 
  51  { echo "The test passed!!!"
  52    echo "$*" 1>&2
  53    exit 0
  54  } #end of pass()
  55 
  56 #Call this to run the test with a file name
  57 test()
  58  {
  59    ${TESTJAVA}${FILESEP}bin${FILESEP}appletviewer -Xnosecurity ${URL} > err 2>&1 &
  60    APPLET_ID=$!
  61    sleep 15
  62    kill -9 $APPLET_ID
  63 
  64    # these exceptions will be thrown if the test fails
  65    cat err | grep "I/O exception while reading"
  66    exception=$?
  67    if [ $exception = "0" ];
  68        then fail "test failed for "${URL}", see err file and CRs #6193279,6329251,6376334"
  69    fi
  70 
  71    cat err | grep "java.lang.ClassNotFoundException"
  72    exception=$?
  73    if [ $exception = "0" ];
  74        then fail "test failed for "${URL}", see err file and CRs #6193279,6329251,6376334"
  75    fi
  76 
  77    # the applet will log the same message
  78    cat err | grep "the appletviewer started"
  79    started=$?
  80 
  81    echo $started | grep "2"
  82    if [ $? = 0 ] ;
  83        then fail "test failed for "${URL}": syntax errors or inaccessible files"
  84    fi
  85 
  86    if [ $started = "0" ];
  87        then echo "the test passed for "${URL}
  88        else fail "test failed for "${URL}": the appletviewer behaviour is unexpected: "$started", see err file"
  89    fi
  90  }
  91 
  92 # end of subroutines
  93 
  94 
  95 # The beginning of the script proper
  96 
  97 # Checking for proper OS
  98 OS=`uname -s`
  99 case "$OS" in
 100    SunOS )
 101       VAR="One value for Sun"
 102       DEFAULT_JDK=/usr/local/java/jdk1.2.1/solaris
 103       FILESEP="/"
 104       ;;
 105 
 106    Linux )
 107       VAR="A different value for Linux"
 108       DEFAULT_JDK=/usr/local/java/jdk1.4/linux-i386
 109       FILESEP="/"
 110       ;;
 111 
 112    Windows_95 | Windows_98 | Windows_NT | Windows_ME | CYGWIN_NT-5.1)
 113       VAR="A different value for Win32"
 114       DEFAULT_JDK=/usr/local/java/jdk1.2.1/win32
 115       FILESEP="\\"
 116       ;;
 117 
 118    # catch all other OSs
 119    * )
 120       echo "Unrecognized system!  $OS"
 121       fail "Unrecognized system!  $OS"
 122       ;;
 123 esac
 124 
 125 # 6438730: Only a minimal set of env variables are set for shell tests.
 126 # To guarantee that env variable holds correct value we need to set it ourselves.
 127 if [ -z "${PWD}" ] ; then
 128     PWD=`pwd`
 129 fi
 130 
 131 # check that some executable or other file you need is available, abort if not
 132 #  note that the name of the executable is in the fail string as well.
 133 # this is how to check for presence of the compiler, etc.
 134 #RESOURCE=`whence SomeProgramOrFileNeeded`
 135 #if [ "${RESOURCE}" = "" ] ; 
 136 #   then fail "Need SomeProgramOrFileNeeded to perform the test" ; 
 137 #fi
 138 
 139 # Want this test to run standalone as well as in the harness, so do the 
 140 #  following to copy the test's directory into the harness's scratch directory 
 141 #  and set all appropriate variables:
 142 
 143 if [ -z "${TESTJAVA}" ] ; then
 144    # TESTJAVA is not set, so the test is running stand-alone.
 145    # TESTJAVA holds the path to the root directory of the build of the JDK
 146    # to be tested.  That is, any java files run explicitly in this shell
 147    # should use TESTJAVA in the path to the java interpreter.
 148    # So, we'll set this to the JDK spec'd on the command line.  If none
 149    # is given on the command line, tell the user that and use a cheesy
 150    # default.
 151    # THIS IS THE JDK BEING TESTED.
 152    if [ -n "$1" ] ;
 153       then TESTJAVA=$1
 154       else echo "no JDK specified on command line so using default!"
 155          TESTJAVA=$DEFAULT_JDK
 156    fi
 157    TESTSRC=.
 158    TESTCLASSES=.
 159    STANDALONE=1;
 160 fi
 161 echo "JDK under test is: $TESTJAVA"
 162 
 163 #Deal with .class files:
 164 if [ -n "${STANDALONE}" ] ; 
 165    then 
 166    #if standalone, remind user to cd to dir. containing test before running it
 167    echo "Just a reminder: cd to the dir containing this test when running it"
 168    # then compile all .java files (if there are any) into .class files
 169    if [ -a *.java ] ; 
 170       then echo "Reminder, this test should be in its own directory with all"
 171       echo "supporting files it needs in the directory with it."
 172       ${TESTJAVA}/bin/javac ./*.java ; 
 173    fi
 174    # else in harness so copy all the class files from where jtreg put them
 175    # over to the scratch directory this test is running in. 
 176    else cp ${TESTCLASSES}/*.class . ;
 177 fi
 178 
 179 #if in test harness, then copy the entire directory that the test is in over 
 180 # to the scratch directory.  This catches any support files needed by the test.
 181 #if [ -z "${STANDALONE}" ] ; 
 182 #   then cp ${TESTSRC}/* . 
 183 #fi
 184 
 185 #Just before executing anything, make sure it has executable permission!
 186 chmod 777 ./*
 187 
 188 ###############  YOUR TEST CODE HERE!!!!!!!  #############
 189 
 190 #All files required for the test should be in the same directory with
 191 # this file.  If converting a standalone test to run with the harness,
 192 # as long as all files are in the same directory and it returns 0 for
 193 # pass, you should be able to cut and paste it into here and it will
 194 # run with the test harness.
 195 
 196 # This is an example of running something -- test
 197 # The stuff below catches the exit status of test then passes or fails
 198 # this shell test as appropriate ( 0 status is considered a pass here )
 199 
 200 # The test verifies that appletviewer correctly works with the different
 201 # names of the files, including relative and absolute paths 
 202 
 203 # 6619458: exclude left brace from the name of the files managed by the VCS
 204 NAME='test.html'
 205 
 206 ENCODED='te%7Bst.html'
 207 UNENCODED='te{st.html'
 208 
 209 # Copy needed files into the harness's scratch directory
 210 # or create a copy with the required name if the test is
 211 # running as stand-alone
 212 cp ${TESTSRC}${FILESEP}${NAME} ${UNENCODED}
 213 
 214 # the encoded name, the path is absolute
 215 URL="file:"${PWD}${FILESEP}${ENCODED}
 216 test
 217 
 218 # the encoded name, the path is relative
 219 URL="file:"${ENCODED}
 220 test
 221 
 222 # the unencoded name, the path is absolute
 223 URL="file:"${PWD}${FILESEP}${UNENCODED}
 224 test
 225 
 226 # the unencoded name, the path is relative
 227 URL="file:"${UNENCODED}
 228 test
 229 
 230 # pick up our toys from the scratch directory
 231 rm ${UNENCODED}